import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;

public class Figurtegning extends JFrame {
	JLabel jLabelVlgFigur = new JLabel();
	JComboBox jComboFigliste = new JComboBox();
	JButton jButtonOpret = new JButton();
	JButton jButtonFortryd = new JButton();
	JButton jButtonGruppr = new JButton();

	Palette palette = new Palette();
	Point musPos = new Point(10,10);
	ArrayList figurerPSkrmen = new ArrayList();
	Historik historik = new Historik();

	public Figurtegning() {
		try {
			jbInit();
		}
		catch(Exception ex) {
			ex.printStackTrace();
		}
		palette.tilfj("Cirkel", new Cirkel(10,10,10));
		palette.tilfj("StorCirkel", new Cirkel(10,10,50));
		palette.tilfj("Firkant", new Firkant(0,0,20,20));

		jComboFigliste.setModel(new DefaultComboBoxModel(palette.navneliste().toArray()));
	}

	void jbInit() throws Exception {
		jLabelVlgFigur.setText("Vlg figur");
		jLabelVlgFigur.setBounds(new Rectangle(304, 31, 73, 26));
		this.getContentPane().setLayout(null);
		jComboFigliste.setBounds(new Rectangle(305, 62, 90, 24));
		jButtonOpret.setBounds(new Rectangle(306, 94, 88, 25));
		jButtonOpret.setText("Opret");
		jButtonOpret.addActionListener(new Figurtegning_jButtonOpret_actionAdapter(this));
		this.addMouseListener(new Figurtegning_this_mouseAdapter(this));
		this.addMouseMotionListener(new Figurtegning_this_mouseMotionAdapter(this));
		jButtonFortryd.setBounds(new Rectangle(310, 259, 85, 25));
		jButtonFortryd.setText("fortryd");
		jButtonFortryd.addActionListener(new Figurtegning_jButtonFortryd_actionAdapter(this));
		jButtonGruppr.setBounds(new Rectangle(308, 141, 85, 25));
		jButtonGruppr.setText("gruppr");
		jButtonGruppr.addActionListener(new Figurtegning_jButtonGruppr_actionAdapter(this));
		this.getContentPane().add(jComboFigliste, null);
		this.getContentPane().add(jButtonOpret, null);
		this.getContentPane().add(jLabelVlgFigur, null);
		this.getContentPane().add(jButtonFortryd, null);
		this.getContentPane().add(jButtonGruppr, null);
	}

		public void paint(Graphics g) {
			super.paint(g);
			for (int i=0; i<figurerPSkrmen.size(); i++) {
				Figur fig = (Figur) figurerPSkrmen.get(i);
				fig.tegn(g);
			}
		}


	void this_mousePressed(MouseEvent e) {
		musPos = e.getPoint();
	}

	/** Find en figur tt p og ryk den hen til musen */
	void this_mouseDragged(MouseEvent e) {
		musPos = e.getPoint();
		for (int i=0; i<figurerPSkrmen.size(); i++) {
			Figur fig = (Figur) figurerPSkrmen.get(i);
			if (musPos.distance(fig.x, fig.y)<15) {

				//fr Kommando: fig.x = musPos.x;
				//fr Kommando: fig.y = musPos.y;
				historik.udfr(new Flytkommando(fig, musPos.x-fig.x, musPos.y-fig.y));
				repaint();
				break;
			}
		}
	}

	void jButtonOpret_actionPerformed(ActionEvent e) {
		int figurNr = jComboFigliste.getSelectedIndex();
		Figur fig = palette.opretFigur(figurNr,musPos.x, musPos.y);
		//fr Kommando: figurerPSkrmen.add(fig);
		historik.udfr(new Opretkommando(fig,figurerPSkrmen));
		repaint();
	}

	void jButtonFortryd_actionPerformed(ActionEvent e) {
		historik.fortryd();
		repaint();
	}

	void jButtonGruppr_actionPerformed(ActionEvent e) {
		Figur f = new Figurgruppe(musPos.x, musPos.y, figurerPSkrmen);
		palette.tilfj("gruppe"+palette.navneliste().size(),f);
		jComboFigliste.setModel(new DefaultComboBoxModel(palette.navneliste().toArray()));
		figurerPSkrmen.clear();
		repaint();
	}


	public static void main(String[] args) {
		Figurtegning Figurtegning = new Figurtegning();
		Figurtegning.setSize(500,400);
		Figurtegning.setVisible(true);
	}
}


class Figurtegning_jButtonOpret_actionAdapter implements java.awt.event.ActionListener {
	Figurtegning adaptee;

	Figurtegning_jButtonOpret_actionAdapter(Figurtegning adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
		adaptee.jButtonOpret_actionPerformed(e);
	}
}

class Figurtegning_this_mouseAdapter extends java.awt.event.MouseAdapter {
	Figurtegning adaptee;

	Figurtegning_this_mouseAdapter(Figurtegning adaptee) {
		this.adaptee = adaptee;
	}
	public void mousePressed(MouseEvent e) {
		adaptee.this_mousePressed(e);
	}
}

class Figurtegning_this_mouseMotionAdapter extends java.awt.event.MouseMotionAdapter {
	Figurtegning adaptee;

	Figurtegning_this_mouseMotionAdapter(Figurtegning adaptee) {
		this.adaptee = adaptee;
	}
	public void mouseDragged(MouseEvent e) {
		adaptee.this_mouseDragged(e);
	}
}

class Figurtegning_jButtonFortryd_actionAdapter implements java.awt.event.ActionListener {
	Figurtegning adaptee;

	Figurtegning_jButtonFortryd_actionAdapter(Figurtegning adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
		adaptee.jButtonFortryd_actionPerformed(e);
	}
}

class Figurtegning_jButtonGruppr_actionAdapter implements java.awt.event.ActionListener {
	Figurtegning adaptee;

	Figurtegning_jButtonGruppr_actionAdapter(Figurtegning adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
		adaptee.jButtonGruppr_actionPerformed(e);
	}
}
